// ==UserScript==
// @name        inject
//
// @include     http://*
// @include     https://*

// ==/UserScript==

function Rubar()
{
    console.log( 'Rubar function call' );

	var self = this;

    this.Pref = {
		write : function (pref, value) {
			widget.preferences[pref] = value;
		},
		read : function (pref) {
			return widget.preferences[pref];
		}
	};

	this.log = function(arg) {
		console.log(arg);
	};

    this.fnCallbacks = {};

	this.rssButton = {};

	this.browser = {
		openUILink: function(url, newtab) {
			var newtab = newtab ? newtab : false;
			opera.extension.postMessage({
				action:'rubar_browser_navigate',
				url: unescape(url),
				newtab: newtab
			});
		}
	};

	this.toolbar = {
		getXMLHttpRequest : function (method, url, data, fnCallback) {
			opera.extension.postMessage({
				action: 'ruBar_xmlHttpRequest',
				url:	url,
				mehod: method,
				data: 	data
			});
			self.fnCallbacks['ruBar_xmlHttpRequest_' + url] = fnCallback;
		},

		widgetRequest: function(widget, data, callback, index){
			if(typeof widget == 'string'){
				widget = {
					widget: widget,
					id: index
				};
			}
			opera.extension.postMessage({
				'action': 'ruBar_widgetRequest',
				'widget':	widget.widget,
				'id':	widget.id,
				'data': data
			});
			self.fnCallbacks['ruBar_widgetRequest_' + widget.widget + widget.id] = callback;
		},

		newButtonControl: function(btnInfo, index) {
			return this.newButton(null, btnInfo, function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		newLogo: function(btnInfo, index) {
			$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		rubarButton: function(btnInfo, index) {
			$('<div />').rubarButton($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		newHtmlControl: function(btnInfo, index) {
			var id = "RubarHtmlControl" + index;
			var caption = $$(btnInfo).find('caption').text();
			var btnwidth = $$(btnInfo).find('btnwidth').text();
			var btnlink = $$(btnInfo).find('btnlink').text();
			$$('<div />')
				.attr("id", id)
				.css({
					"width": btnwidth + "px",
					"height":"30px",
					"margin":"0px",
					"border": "1px solid #eee",
					"float": "left",
					"padding":"1px"
				})
				.addClass('rubar-button')
				.appendTo('#RubarToolbar');
			if (btnlink != '')
				loadTextContent('data/' + btnlink, id, function(text){
					$$('#' + id).html(text);
				});
		},

		newHtmlButton: function(btnInfo, index) {
			$('<div />').newHtmlButton($$(btnInfo), null, index);
		},

		newSearchControl: function(btnInfo, index) {
			var link = decodeURIComponent($$(btnInfo).find('link').text());
			var icon = $$(btnInfo).find('icon').text();
			var caption = $$(btnInfo).find('caption').text();
			var tooltip = $$(btnInfo).find('tooltip').text();
			var guid = $$(btnInfo).find('guid').text();
			var id = "rubar-searchcontrol" + index;
			var idInput = "rubar-searchcontrol-input" + index;
			var idButton = "rubar-searchcontrol-button" + index;
			var $div = $$("<div />")
				.css({
					"width":"auto !important",
					"height":	"28px",
					"margin":	"0px",
					"border": 	"0px",
					"float":	"left",
					"padding":	"0px"
				})
				.attr("id", id)
				.appendTo('#RubarToolbar')
			var $input = $$( "<input />" )
				.appendTo( $div )
				.attr("id", idInput)
				.addClass("rubar-search-input")
				.attr( "name", "name");

			var $button = $$( "<div />" )
				.appendTo( $div )
				.attr("id", idButton)
				.addClass('rubar-button');

			// image
			if (icon != '') {
				$$('<div />')
					.attr("id", idButton + "_icon")
					.addClass('rubar-button-icon')
					.appendTo($button);
				loadBinContent(idButton + "_icon", 'data/packages/' + guid + '/' + icon);
			}
			if (caption != '') {
				$$('<p />')
					.text(caption)
					.addClass('rubar-button-caption')
					.appendTo($button);
			}
			if (tooltip != '')
				$button.attr('title', tooltip);

			if (link != null)
				$button.attr("link", link);

			$button.click(function(){
				var text = $$("#" + idInput).attr('value');
				if (text == "")
                {
					return;
                }

                var link = $$(this).attr('link');
				link = link.replace( "{MYSEARCHTERM}", text + "&clid=" + self.clids[0] );
				self.browser.openUILink( link );

				reportComponentUsage( 'search', link );
			});

            $input.keypress(function(aEvent) {
				if (aEvent.which == '13') {
					$button.click();
				}
			});

			$input.autocomplete({
				source: function( request, response ) {
					var url = "http://suggest.yandex.ru/suggest-ya.cgi?ct=text/html&part=" + encodeURIComponent(request.term);
					rubar.toolbar.getXMLHttpRequest('GET', url, {}, function(respText) {
						var istart = respText.indexOf("[", respText.indexOf("[") + 1);
						var parsed = respText.substr(istart, respText.indexOf("]", istart) - istart + 1);
						response(JSON.parse(parsed));
					});
				},
				select: function(event, ui) {
					$button.click();
				},
				minLength: 2
			});

            $input.click(function(e) {
				//$.StatLogger.LOG_STAT("stat", "search_field_click");
			});

			var input = $input.get(0);
			window.addEventListener("mouseup", function(e) {
				if(e.target == input)
					return;
				var selText = window.getSelection().toString();
				if (input.value != selText && selText.length )
				   input.value = selText;
			}, false);

			return $div;
		},

		newHtmlPopup: function(btnInfo, index) {
			//
		},

		newWeatherButton: function(btnInfo, index) {
			var script = $$(btnInfo).find('script') ? $$(btnInfo).find('script').text(): null;
			var link = $$(btnInfo).find('link') ? $$(btnInfo).find('link').text(): null;
			var icon = $$(btnInfo).find('icon').text();
			var caption = $$(btnInfo).find('caption').text();
			var tooltip = $$(btnInfo).find('tooltip').text();
			var guid = $$(btnInfo).find('guid').text();
			if (script) {
				eval(script);
			}
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: caption,
				icon: icon,
				guid: guid,
                iconClass: 'rubar-weather-icon'
			});

            dropDownButton.$button.weather({
				index: 		index,
				button:		dropDownButton.$button,
				infoButton:	dropDownButton.children.$button,
				buttonDown:	dropDownButton.children.$buttonDown,
				label: 		dropDownButton.children.$label,
				icon:		dropDownButton.children.$icon,
				guid:		guid
			});
			var refresh = parseInt(rubar.Pref.read('weather.refresh'));
			refresh = (refresh > 1) ? refresh : 1;
			refresh = (refresh < 24) ? refresh: 24;
			opera.extension.postMessage({
				action: 'ruBar_setInterval',
				name:	"rubar-weather" + index,
				interval: 1000 * 60 * 24 * refresh
			});
			self.fnCallbacks['ruBar_setInterval_' + "rubar-weather" + index] = function() {
				dropDownButton.$button.weather('onRequest');
			};
			dropDownButton.$button.weather('onRequest');
		},

		newRadioButton: function(btnInfo, index) {
			//
		},

		newRSSButton: function(btnInfo, index) {
			// Parse main RSS channel data
			var link = $$(btnInfo).find('link') ? $$(btnInfo).find('link').text(): null;
			var icon = $$(btnInfo).find('icon').text();
			var guid = $$(btnInfo).find('guid').text();
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: "",
				icon: icon,
				guid: guid
			});

			dropDownButton.$button.menuRss({
				index: index,
				buttonDown: dropDownButton.children.$buttonDown
			});

			function RequestRSS() {
				rubar.toolbar.getXMLHttpRequest('GET', unescape(link), {}, function(respText) {
					var parser = new window.DOMParser();
					var xml = parser.parseFromString(respText, "text/xml");
					var channel = xml.getElementsByTagName("channel")[0];
					dropDownButton.$button.attr('link', $$(channel).children("link").text());
					dropDownButton.children.$label.text($$(channel).children("title").text());
					dropDownButton.$button.menuRss('loadChannel', channel);
				});
			}

			rubar.Pref.write("lastRSSIndex", "0");
			opera.extension.postMessage({
				action: 'ruBar_setInterval',
				name:	"rubar-rss" + index,
				interval: parseInt(rubar.Pref.read('rss.refresh')) * 1000 * 60
			});
			self.fnCallbacks['ruBar_setInterval_' + "rubar-rss" + index] = RequestRSS;

			RequestRSS();
		},

		newMultiRSSButton: function(btnInfo, index) {
			//
		},

		newDropDownButton: function(param) {
			var index = param.index;
			var link = param.link;
			var caption = param.caption;
			var icon = param.icon;
			var guid = param.guid;

            var iconClass = param.iconClass || 'rubar-button-icon';

			if ($$("#rubar-dropdown-button" + index).length > 0) {
				$dropDownButton = $$("#rubar-dropdown-button" + index);
				$button = $$("#rubar-button" + index);
				$label = $$("#rubar-button-caption" + index);
				$buttonDown = $$("#rubar-buttonDown" + index);
			} else {
				var $dropDownButton = $$("<div />")
					.attr("id", "rubar-dropdown-button" + index)
					.addClass('rubar-button')
					.appendTo('#RubarToolbar')
				var $button = $$("<div />")
					.css({
						"height":	"24px",
						"float":	"left",
						"padding":"0px"
					})
					.attr('id', 'rubar-button' + index)
					.appendTo($dropDownButton);
				if (link) {
					$button.attr('link', link)
					$button.click(function() {
						var url = $$(this).attr('link');
						rubar.browser.openUILink(url);
					})
				}
				var $icon = null;
				$icon = $$('<div />')
					.attr("id", "rubar-button-icon" + index)
					.addClass( iconClass )
					.appendTo("#rubar-button" + index);
				if (icon != '') {
					loadBinContent("rubar-button-icon" + index, 'data/packages/' + guid + '/' + icon);
				}
				$label = $$('<p />')
					.text(caption)
					.attr('id', 'rubar-button-caption' + index)
					.addClass('rubar-button-caption')
					.appendTo("#rubar-button" + index);

				var $buttonDown = $$("<div />")
					.css({
						"height":	"24px",
						"border-left": "1px solid #dce1ee",
						"float":	"left",
						"padding":	"0px"
					})
					.attr('id', 'rubar-buttonDown' + index)
					.append($$('<div />')
						.attr("id", "rubar-button-down-icon" + index)
						.addClass('rubar-button-icon-empty')
						.addClass('rubar-button-icon-down')
					)
					.appendTo($dropDownButton);
				}

			return {
				$button: $dropDownButton,
				children: {
					$button: $button,
					$label: $label,
					$buttonDown: (link) ? $buttonDown: $dropDownButton,
					$icon: $icon
				}
			};
		},

		newMenuButton: function(btnInfo, index) {
			var link = $$(btnInfo).find('link')? decodeURIComponent($$(btnInfo).find('link').text()): null;
			var icon = decodeURIComponent($$(btnInfo).find('icon').text());
			var caption = decodeURIComponent($$(btnInfo).find('caption').text());
			var guid = $$(btnInfo).find('guid').text();
			var menu = $$(btnInfo).find('menuitems');
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: caption,
				icon: icon,
				guid: guid
			});
			dropDownButton.$button.popupMenu({
				menu: menu,
				index: index,
				buttonDown: dropDownButton.children.$buttonDown,
				guid: guid
			});
			//dropDownButton.$button.popupMenu('reload', menu);
			return dropDownButton.$button;
		},

		newButton: function(id, btnInfo, commandFunc, index)  {
			var link = decodeURIComponent($$(btnInfo).find('link:first').text());
			var icon = $$(btnInfo).find('icon:first').text();
			var caption = $$(btnInfo).find('caption:first').text();
			var tooltip = $$(btnInfo).find('tooltip:first').text();
			var guid = $$(btnInfo).find('guid').text();
			var id = "RubarControl" + index;
			var $button = $$('<div />')
				.attr("id", id)
				.addClass('rubar-button')
				.appendTo('#RubarToolbar');

            if (id != null)
            {
				$button.attr("id", id);
            }

			// image
			if (icon != '') {
				$$('<div />')
					.attr("id", id + "_icon")
					.addClass('rubar-button-icon')
					.appendTo($button);
				loadBinContent(id + "_icon", 'data/packages/' + guid + '/' + icon);
			}

			if (caption != '') {
				$$('<p />')
					.text(caption)
					.addClass('rubar-button-caption')
					.appendTo($button);
			}

			if (tooltip != "")
            {
				$button.attr("title", tooltip);
            }

            if (link != null)
            {
				$button.attr("link", link);
            }

            if (commandFunc != null)
            {
				$button.click(function(){
					if(!this.getAttribute('disabled'))
						commandFunc($button);
				});
            }

			return $button;
		},

		/* Creates popup item to menu */
		newPopupMenu: function(menuId, onshow) {
			return null;
		},

		newSeparator: function(btnInfo, index) {
			$('<div />').separator($$(btnInfo), index);
		},

		newSettingsButton: function(btnInfo, index) {
			$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"), true);
            }, index);
		},

		newMail: function(btnInfo, index) {
			/*$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"), true);
            }, index);*/
			$$("<div />")
				.addClass("ruBar_widgetRequest_mailchecker")
				.mailchecker({
					toolbar: rubar.toolbar,
					config: btnInfo,
					index: index
				})
				.appendTo("#RubarToolbar");
		}
	};
}