﻿// ==UserScript==
// @name        inject
//
// @include     http://*
// @include     https://*

// ==/UserScript==

var rubar = null;

(function() {
	if( window.top != window.self )
    {
		return;
    }

    rubar = new Rubar();

	var evName = '';
	var evalued = {};

    // ---------------------- browser events ------------------------------
    window.addEventListener( 'DOMContentLoaded', function() {
        scriptLoader.fire();
        var bVisible =  (widget.preferences['visible'] != null) ? widget.preferences['visible'] : true;
        bVisible = fixBoolPref(bVisible);
        showToolbarTrigger(bVisible);
        window.setTimeout(function() {
            opera.extension.postMessage({
                action: 'LoadInjectedCSS',
                data: 'css/style.css'
            });
            opera.extension.postMessage({
                action: 'LoadInjectedCSS',
                data: 'css/jquery-ui-1.8.6.custom.css'
            });
        }, 500);

        opera.extension.addEventListener( 'message', eventListener, false );

    }, false );

    opera.extension.ondisconnect = function(e) {
        showToolbarTrigger( false );
    }
	
	function showContent(data)
    {
		initPopupMenuWidget( $$ );
		
		//console.log("data = " + data);
		var xmlDoc = $$.parseXML(data);
		var xml = $$(xmlDoc);
		var $layouts = xml.find("layout");
		$$.each($layouts.children(), function(i, $item) {
			var type = $$(this).find('type').text();
			switch(type) {
				case "custombutton":
					rubar.toolbar.newButtonControl(this, i);
					break;
				case "separator":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newSeparator(this, i);
					break;
				case "settings_button":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newSettingsButton(this, i);
					break;					
				case "logo":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newLogo(this, i);
					break;
				case "button":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.rubarButton(this, i);
					break;
				case "search":
					rubar.toolbar.newSearchControl(this, i);
					break;
				case "htmlpopup":
					rubar.toolbar.newHtmlPopup(this, i);
					break;
				case "htmlbutton":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newHtmlButton(this, i);
					break;
				case "htmlcontrol":
					//evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					//rubar.toolbar.newHtmlControl(this, i);
					break;
				case "weather":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newWeatherButton(this, i);
					break;
				/*case "currency":
					rubar.toolbar.newCurrencyButton(this, i);
					break;*/					
				case "radio":
					rubar.toolbar.newRadioButton(this, i);
					break;
				case "native":
					break;
				case "mail":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newMail(this, i); 	
					break;
				case "rss":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newRSSButton(this, i); 	
					break;
				case "multirss":
					rubar.toolbar.newMultiRSSButton(this, i);
					break;
				case "menu":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newMenuButton(this, i);
					break;
				default: 
					//-- Widget factory
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					if ($$.fn[type]) {
						$$("<div />")
							.addClass("ruBar_widgetRequest_" + type)[type]({
								toolbar: rubar.toolbar,
								config: this,
								index: i
							})
							.appendTo("#RubarToolbar");
					}
					//-- End of Widget factory
                    break;
			}
		});
	}

	function evalScript(type, script) {
		if (!evalued[type] && script) {
			evalued[type] = true;
			eval(script);
		}		
	}

	function showToolbarTrigger( isVisible )
    {
		if (!isVisible && $$('#RubarToolbar').length != 0)
        {
			$$("#RubarToolbarPopup").remove();
			$$('#RubarToolbar').toolbar('hide');
			removeStyle("ruBar_div_cuzadpn");
		}
        else if(isVisible && $$('#RubarToolbar').length == 0)
        {
			//setStyle("div.cuzadpn { top: 30px !important }", "ruBar_div_cuzadpn");
			$$('<div />')
				.attr("id","RubarToolbar")
				.appendTo( window.document.documentElement )
                //.appendTo( window.document.body )
				.toolbar();

            window.setTimeout(function() {
                opera.extension.postMessage({
                    action: 'rubar_getClids'
                });
                opera.extension.postMessage({
					action: 'rubar_loadContent'
				});
			}, 500);
		}
	}

	function openPopup(options) {
		$$("#RubarToolbarPopup").remove();
		$$("<iframe />")
			.attr("id", "RubarToolbarPopup")
			.popup(options);
	}

	function closePopup() {
		$$("#RubarToolbarPopup").remove();
	}

	function ruBarRemoveEventListener(eventname) {
		document.removeEventListener(eventname, eventListener, false);
	}

	function ruBarAddEventListener(eventname) {
		evName = eventname;
		document.addEventListener(eventname, eventListener, false);
	}

	function eventListener(e) {
		opera.extension.postMessage({
			action: 'ruBar_eventListener',
			name:	evName,
			value:	'undefined'
		});
	}

	function setCookie(name, value, expiresDate) {
		var exdate = new Date(expiresDate);
		var val = escape(value) + ((expiresDate == null) ? "" : "; expires=" + exdate.toUTCString());
		var str = name + "=" + val
		document.cookie = str;
	}

	function getCookie(name) {
		var _name, val, cookies = document.cookie.split(";");
		for (var i = 0; i < cookies.length; i++) {
			_name = cookies[i].substr(0, cookies[i].indexOf("="));
			val = cookies[i].substr(cookies[i].indexOf("=") + 1);
			_name = _name.replace(/^\s+|\s+$$/g, "");
			if (_name == name) {
				return unescape(val);
			}
		}
	}

	function setStyle(css, id) {
		var s = document.createElement('style');
		s.setAttribute('id', id);
		s.setAttribute('type', 'text/css');         
		s.appendChild(document.createTextNode(css));
		document.getElementsByTagName('head')[0].appendChild(s);
	}

	function removeStyle(id) {
		$$('#' + id).remove();
	}

    function eventListener( event )
    {
        if( !event || !event.data || !event.data.action )
        {
            return;
        }

        var msg = event.data;
        switch( msg.action )
        {
            case 'rubar_tb_showToolbarTrigger':
                showToolbarTrigger(msg.visible);
                return;

            case 'ruBar_openPopup' :
                openPopup(msg.options);
                return;

            case 'ruBar_closePopup' :
                closePopup();
                return;

            case 'rubar_showContent':
                showContent(msg.xml);
                return;

            case 'css':
                setStyle(msg.data.css, 'RubarToolbarCustomStyleNoPrint');
                return;

            case 'rubar_loadTextContent':
                if (typeof rubar.fnCallbacks['rubar_loadTextContent_' + msg.name] != 'undefined') {
                    rubar.fnCallbacks['rubar_loadTextContent_' + msg.name](msg.content);
                    delete rubar.fnCallbacks['rubar_loadTextContent_' + msg.name];
                }
                return;

            case 'rubar_getClids':
                rubar.clids = event.data.clids;
                break;

            case 'rubar_loadBinContent':
                switch( msg.attr )
                {
                    case 'background-image':
                        $$('#' + msg.id).css({
                            "background-image" : "url('data:image/png;base64," + msg.content + "')"
                        });
                        break;
                    case 'src':
                        $$('#' + msg.id).attr( 'src', 'data:image/png;base64,' + msg.content );
                        break;
                }
                return;

            case 'ruBar_setControlWidth':
                $$('#' + msg.controlname).css({
                    "width" : msg.width + "px"
                });
                return;

            case 'ruBar_setCookie':
                setCookie(msg.name, msg.value, msg.expiresDate);
                return;

            case 'ruBar_getCookie':
                opera.extension.postMessage({
                    action: 'ruBar_getCookieVar',
                    name: msg.name,
                    value: getCookie(msg.name)
                });
                return;

            case 'ruBar_addEventListener':
                ruBarAddEventListener(msg.name);
                return;
            case 'ruBar_removeEventListener':
                ruBarRemoveEventListener(msg.name);
                return;
            case 'ruBar_xmlHttpRequest':
                if (typeof rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url] != 'undefined') {
                    rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url](msg.xhr.responseText);
                    delete rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url];
                }
                return;
            case 'ruBar_setInterval':
                if (typeof rubar.fnCallbacks['ruBar_setInterval_' + msg.name] != 'undefined') {
                    rubar.fnCallbacks['ruBar_setInterval_' + msg.name](msg.data);
                    //delete rubar.fnCallbacks['ruBar_setInterval_' + msg.name];
                }
                return;
            case 'ruBar_widgetResponse':
                if (typeof rubar.fnCallbacks['ruBar_widgetRequest_' + msg.widget+ msg.id] != 'undefined') {
                    rubar.fnCallbacks['ruBar_widgetRequest_' + msg.widget + msg.id](msg.data);
                }
                return;
            case 'ruBar_widgetRequest':
                if ($$(".ruBar_widgetRequest_" + msg.widget)) {
                    $$(".ruBar_widgetRequest_" + msg.widget)[msg.widget]('onRequest', msg.data);
                }
                return;
        }
    }
})();

/* ******************************* popupMenu ************************************** */
function initPopupMenuWidget( $$ )
{
    (function( $$ ) {
        var index, guid;
        $$.widget( "ui.popupMenu", {

            options: {
                appendTo: document.documentElement,
                //appendTo: document.body,
                position: {
                    my: "left top",
                    at: "left bottom",
                    collision: "true"
                }
            },

            reload: function() {
                var menu = this.options.menu;
                $$("#rubar-menu" + this.index).children().remove();
                this.menu = $$("#rubar-menu" + this.index);
                this.items = $$(menu).children("item").map(function(i, item){
                    return {
                        label: $$(this).attr('text'),
                        hint: $$(this).attr('text'),
                        link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
                        icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
                        submenu: $$(this).children('item') ? $$(this).children('item') : null
                    }
                });
                this._renderMenu( this.menu, this.items );
                this.menu.menu('refresh');
            },

            _create: function() {
                var widget = this;
                var self = this.element;
                var menu = this.options.menu;
                guid = this.options.guid;
                this.index = this.options.index;
                var buttonDown = this.options.buttonDown;
                this.level = 1;

                if ($$('#rubar-menu' + index).length == 0) {
                    buttonDown.click(function(){
                        if ( widget.menu.is(":visible") ) {
                            $$(".tbui-menu").hide();
                            //$$("ul[level=2]").hide();
                            widget.close();
                        } else {
                            widget.open();
                        }
                    });

                    this.menu = $$( "<ul />" )
                        .appendTo( $$( this.options.appendTo || "body" )[0] )
                        .attr('level', this.level)
                        .css({top: 0, left: 0, position: 'fixed' })
                        .zIndex("999990 !important" )
                        .attr('id', 'rubar-menu' + this.index)
                        .hide();
                    this.items = $$(menu).children("item").map(function(i, item){
                        return {
                            label: $$(this).attr('text'),
                            hint: $$(this).attr('text'),
                            link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
                            icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
                            submenu: $$(this).children('item') ? $$(this).children('item') : null
                        }
                    });
                    this._renderMenu( this.menu, this.items );
                    this.menu.menu();
                } else {
                    $$("#rubar-menu" + this.index).children().remove();
                    this.menu = $$("#rubar-menu" + this.index);
                    this.items = $$(menu).children("item").map(function(i, item){
                        return {
                            label: $$(this).attr('text'),
                            hint: $$(this).attr('text'),
                            link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
                            icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
                            submenu: $$(this).children('item') ? $$(this).children('item') : null
                        }
                    });
                    this._renderMenu( this.menu, this.items );
                    this.menu.menu('refresh');
                }

                function triggerCloseEvent(event) {
                    if (widget.menu.is(":visible") ) {
                        widget.close();
                        event.originalEvent.preventDefault();
                    }
                }

                $$(window).resize(triggerCloseEvent);
                //$$(window).scroll(triggerCloseEvent);
                $$(document.body).click(triggerCloseEvent);
                $$(this.menu).click(triggerCloseEvent);
            },

            open: function ( event ) {
                $$(".tbui-menu").hide();
                this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
                this.menu.show().position( $$.extend({
                    of: this.element
                }, this.options.position ));
            },

            close: function( event ) {
                if ( this.menu.is(":visible") ) {
                    this._trigger( "close", event );
                    this.menu.hide();
                }
            },

            _renderMenu: function( ul, items ) {
                var self = this;
                $$.each( items, function( index, item ) {
                    self._renderItem( ul, item, index );
                });
            },

            _renderItem: function( ul, item, index) {
                var buttonIconId = "rubar-popupmenu-button-icon" + this.level + "_" + index;
                var $li = $$( "<li />" )
                    .data( "item.menu", item )
                    .appendTo( ul );
                if (item.label == ''){
                        $li.addClass('tbui-menu-item-separator')
                } else {
                    var $a = $$( "<a />" )
                        .append( $$( "<div />" )
                            .attr("id", buttonIconId)
                            .addClass('rubar-menu-item-icon')
                        )
                        .append($$('<p />')
                            .text( item.label)
                            .addClass('rubar-button-caption')
                        )
                        .attr("title", item.hint)
                        .css({height:'24px'})
                        .appendTo( $li );

                    var $button = $$('<div />')
                        .addClass('rubar-button-icon-empty')
                        .appendTo($a);
                    if (item.icon != '') {
                        loadBinContent(buttonIconId, 'data/packages/' + guid + '/' + item.icon);
                    }
                    if (item.link != '') {
                        $li.click(function() {
                            //alert(item.link);
                            rubar.browser.openUILink(item.link);
                        });
                    }
                    if (item.submenu.length > 0) {
                        $button.addClass('rubar-button-icon-right');
                        var $subMenu = $li.popupSubMenu({
                            menu: item.submenu,
                            level: this.level + 1,
                            index: 1,
                            guid: guid
                        });
                    }
                    $li.hover(function() {
                        $$("ul[level=2]").hide();
                        if (item.submenu.length > 0) {
                            $subMenu.popupSubMenu('open');
                        }
                    },
                    function() {
                    });
                }
                return $li;
            }
        });
    })( $$ );
}

function getClids() {
	opera.extension.postMessage({
		action: 'rubar_getClids'
	});
}

function reportComponentUsage( inComponentType, inUrl ) {
	opera.extension.postMessage({
		action: 'rubar_reportComponentUsage',
        type: inComponentType,
        url: inUrl
    });
}

// -----------------------------------------------------------------------------------------------
function loadBinContent(id, path, attr) {
	opera.extension.postMessage({
		action: 'rubar_loadBinContent',
		path: path,
        attr: attr || 'background-image',
		id: id
	});
}

function loadTextContent(path, name, callback) {
	opera.extension.postMessage({
		action: 'rubar_loadTextContent',
		path: path,
		name: name
	});
	rubar.fnCallbacks['rubar_loadTextContent_' + name] = callback;
}

function fixBoolPref(name) {
	if (name == "false")
		return false;
	if (name == "true")
		return true;
	return name;
}